<?php
/* --------------------------------------------------------------
   Amazon Pay  V3.1.0
   main.php 2017-02-10

   alkim media
   http://www.alkim.de

   patworx multimedia GmbH
   http://www.patworx.de/

   Released under the GNU General Public License
   --------------------------------------------------------------
*/

require_once(DIR_FS_CATALOG . 'AmazonLoginAndPay/.config.inc.php');

if (strpos($PHP_SELF, 'checkout_confirmation.php') !== false && $_SESSION["payment"] == 'am_apa') {
    unset($_SESSION["payment"]);
}

if (
    (isset($_SESSION["amz_access_token_set_time"]) && $_SESSION["amz_access_token_set_time"] < time() - 600)
    ||
    (!isset($_SESSION["amz_access_token_set_time"]) && isset($_SESSION["amz_access_token"]))
) {
    unset($_SESSION["amz_access_token"]);
}

if (strpos($PHP_SELF, 'checkout_amazon_change_payment') === false && strpos($PHP_SELF, 'checkout_amazon_login_processing') === false) {
    unset($_SESSION["amazon_special_action"]);
}

switch ($_SESSION["language"]) {
    case 'french':
        $amzLang = 'fr-FR';
        break;
    case 'italian':
        $amzLang = 'it-IT';
        break;
    case 'spanish':
        $amzLang = 'es-ES';
        break;
    case 'german':
        $amzLang = 'de-DE';
        break;
    default:
        $amzLang = 'en-GB';
        break;
}
$amzLogoutFlag = false;
if(
    strpos($_SERVER['PHP_SELF'], 'logoff.php') !== false || strpos($PHP_SELF, 'logoff.php') !== false 
        || 
    (isset($amzAction) && $amzAction  = 'logout')
        || 
    isset($_GET["amz_logout"])
  ){
            unset($_SESSION["amz_access_token"]);
            unset($_SESSION["amz_access_token_set_time"]);
            unset($_SESSION['amazon_id']);
            unset($_SESSION['pay_existing_order_amazon_id']);
            unset($_SESSION["AMZ_COUNTRY_ID"]);
            unset($_SESSION["AMZ_POSTCODE"]);
            unset($_SESSION["AMZ_ZONE_ID"]);
            if ($_SESSION['customer_is_amz_account'] && MODULE_PAYMENT_AM_APA_LPA_MODE == 'pay') {
                unset($_SESSION['customer_id']);
            }
            unset($_SESSION['customer_is_amz_account']);
            $amzLogoutFlag = true;
}

$scope = 'profile postal_code payments:widget payments:shipping_address payments:billing_address';
$isSsl = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off') || $_SERVER['SERVER_PORT'] == 443);
$forceRedirect = (MODULE_PAYMENT_AM_APA_POPUP == 'False' || strpos($_SERVER['PHP_SELF'], 'checkout_payment.php') !== false);
$useRedirect = ($forceRedirect || !$isSsl);
$unallowed_modules = explode(',', $_SESSION['customers_status']['customers_status_payment_unallowed'] . ',' . $order->customer['payment_unallowed']);
$sellerId = MODULE_PAYMENT_AM_APA_MERCHANTID;
$sLeft = $xtPrice->currencies[$xtPrice->actualCurr]['symbol_left'];
$sRight = $xtPrice->currencies[$xtPrice->actualCurr]['symbol_right'];
$currencyCode = (defined('AMZ_CURRENCY')?AMZ_CURRENCY:$xtPrice->actualCurr);
if (
    MODULE_PAYMENT_AM_APA_STATUS == 'True'
    &&
    !in_array('am_apa', $unallowed_modules)
    &&
    !(AMZ_DEBUG_MODE == 'True' && $_SESSION["customers_status"]["customers_status_id"] != 0)
) {
    ?>
    <link rel="stylesheet"
          href="<?php echo DIR_WS_CATALOG; ?>templates/<?php echo CURRENT_TEMPLATE; ?>/amazon-checkout.css"
          type="text/css"/>
    <script type="text/javascript" src="<?php echo DIR_WS_CATALOG; ?>AmazonLoginAndPay/js/static.js"></script>
    <script type="text/javascript">
        var amapa = window.amapa = window.amapa || {};
        window.onAmazonLoginReady = function () {
            amazon.Login.setClientId('<?php echo MODULE_PAYMENT_AM_APA_CLIENTID; ?>');
            <?php if($amzLogoutFlag){ ?>amazonLogout();<?php } ?>
        };
        amapa.isAmazonPaymentsReady = false;
        amapa.isDocumentReady = false;
        window.onAmazonPaymentsReady = function () {
            amapa.isAmazonPaymentsReady = true;
            if (amapa.isDocumentReady) {
                initAmazonPaymentsMaster();
            }
        }
        amapa.waitingImage = '<img src="<?php echo AMZ_WAITING_IMG; ?>" />';
        amapa.baseUrl = '<?php echo xtc_href_link('checkout_amazon_handler.php'); ?>';
        amapa.baseUrl = amapa.baseUrl.replace('https:', '').replace('http:', '');
        amapa.checkoutUrl = '<?php echo xtc_href_link('checkout_amazon.php', 'fromRedirect=1', 'SSL'); ?>';
        amapa.logoutUrl = '<?php echo xtc_href_link('shopping_cart.php', 'amz_logout=1', 'SSL'); ?>';
        amapa.isProductInfo = <?php echo(strpos($PHP_SELF, 'product_info.php') !== false ? 'true' : 'false'); ?>;
        amapa.isRedirect = <?php echo($useRedirect ? 'true' : 'false'); ?>;
        amapa.currency = '<?php echo $currencyCode; ?>';
        
        function initAmazon() {
            var amazonOrderReferenceId;

            var authRequest;
            if ($('.amazonLoginWr').length > 0) {

                $('.amazonLoginWr').each(function () {
                    var thisId = $(this).attr('id');
                    OffAmazonPayments.Button(thisId, "<?php echo $sellerId; ?>", {
                        type: "<?php echo AMZ_BUTTON_TYPE_LOGIN; ?>",
                        size: '<?php echo AMZ_BUTTON_SIZE_LPA; ?>',
                        color: '<?php echo AMZ_BUTTON_COLOR_LPA; ?>',
                        language: '<?php echo $amzLang; ?>',
                        authorization: function () {
                            loginOptions = {
                                scope: "<?php echo $scope; ?>",
                                popup: <?php echo($useRedirect ? 'false' : 'true')?>};
                            authRequest = amazon.Login.authorize(loginOptions<?php echo($useRedirect ? ", '" . xtc_href_link('checkout_amazon_login_processing.php', '', 'SSL', false) . "'" : ''); ?>);
                        },
                        onSignIn: function (orderReference) {
                            if (thisId == 'amazonChangePaymentLogin') {
                                location.reload();
                            } else {
                                var amazonOrderReferenceId = orderReference.getAmazonOrderReferenceId();
                                $.ajax({
                                    type: 'GET',
                                    url: '<?php echo xtc_href_link('checkout_amazon_handler.php', '', $request_type); ?>',
                                    data: 'handleraction=setusertoshop&access_token=' + authRequest.access_token + '&amazon_id=' + amazonOrderReferenceId,
                                    success: function (htmlcontent) {
                                        if (htmlcontent == 'error') {
                                            alert('An error occured - please try again or contact our support');
                                        } else {
                                            window.location = htmlcontent;
                                        }
                                    }
                                });
                            }
                        },
                        onError: function (error) {
                            console.log(error);
                        }
                    });


                });
            }
            <?php 
            if (MODULE_PAYMENT_AM_APA_LPA_MODE != 'login' && !AlkimAmazonHandler::hasCartExcludedProducts()) { 
                ?>
                $('#payWithAmazonDiv, .amazonPayButton').each(function(){
                    var id = $(this).attr('id');
                    $('#'+id).attr('title', '<?php echo AMZ_BUTTON_TOOLTIP; ?>');
                    OffAmazonPayments.Button(id, "<?php echo $sellerId; ?>", {
                        type: "<?php echo AMZ_BUTTON_TYPE_PAY; ?>",
                        size: '<?php echo AMZ_BUTTON_SIZE_LPA; ?>',
                        color: '<?php echo AMZ_BUTTON_COLOR_LPA; ?>',
                        language: '<?php echo $amzLang; ?>',
                        authorization: function () {
                            loginOptions = {
                                scope: "<?php echo $scope; ?>",
                                popup: <?php echo($useRedirect ? 'false' : 'true')?>};
                            authRequest = amazon.Login.authorize(loginOptions<?php echo($useRedirect ? ", '" . xtc_href_link('checkout_amazon_login_processing.php', 'action=checkout', 'SSL', false) . "'" : ''); ?>);
                        },
                        onSignIn: function (orderReference) {
                            amazonOrderReferenceId = orderReference.getAmazonOrderReferenceId();
                            $('#'+id).html('<img src="<?php echo AMZ_WAITING_IMG; ?>" class="amzWaitingImage" /> <?php echo AMZ_WAITING; ?>');
                            $.ajax({
                                type: 'GET',
                                url: '<?php echo xtc_href_link('checkout_amazon_handler.php', '', $request_type); ?>',
                                data: 'handleraction=setusertoshop&access_token=' + authRequest.access_token + '&amazon_target=checkout&amazon_id=' + amazonOrderReferenceId,
                                success: function (htmlcontent) {
                                    if (htmlcontent == 'error') {
                                        alert('An error occured - please try again or contact our support');
                                    } else {
                                        if (amapa.isProductInfo && ($('#' + id).hasClass('buyProductWithAmazonButton') || $('#' + id).hasClass('buyProductWithAmazon'))) {
                                            AmAmazonLoginAndPay.buyProduct($('.buyProductWithAmazonButton'), function () {
                                                window.location.href = amapa.checkoutUrl;
                                            });
                                        } else {
                                            window.location = htmlcontent;
                                        }
                                    }
                                }
                            });
                        },
                        onError: function (error) {
                            console.log(error);
                        }
                    });
                    <?php
                    if(isset($_SESSION["amz_access_token"]) && $_SESSION["amz_access_token"] != ''){
                        ?>
                        var buttonImg = $(this).find('img').attr('src');
                        var $newButton = $('<img src="' + buttonImg + '" style="cursor:pointer;" />');
                        $('#payWithAmazonDiv').html($newButton);
                        $newButton.click(function () {
                            if (amapa.isProductInfo && !amapa.isRedirect) {
                                AmAmazonLoginAndPay.buyProduct($newButton, function () {
                                    window.location.href = amapa.checkoutUrl;
                                });
                            } else {
                                window.location.href = amapa.checkoutUrl;
                            }
                        });
                        <?php
                    }
                    ?>
                });
                <?php 
            }
            ?>
        } //initAmazon()

        <?php
        if (strpos($_SERVER['PHP_SELF'], 'checkout_amazon.php') !== false || strpos($PHP_SELF, 'checkout_amazon.php') !== false) {
            require_once(DIR_FS_CATALOG . 'AmazonLoginAndPay/js/checkout_amazon_js.php');
        } elseif (strpos($_SERVER['PHP_SELF'], 'checkout_amazon_change_payment.php') !== false || strpos($PHP_SELF, 'checkout_amazon_change_payment.php') !== false) {
            require_once(DIR_FS_CATALOG . 'AmazonLoginAndPay/js/checkout_amazon_change_payment_js.php');
        } elseif (strpos($_SERVER['PHP_SELF'], 'checkout_amazon_wallet.php') !== false || strpos($PHP_SELF, 'checkout_amazon_wallet.php') !== false) {
            require_once(DIR_FS_CATALOG . 'AmazonLoginAndPay/js/checkout_amazon_wallet_js.php');
        } elseif (strpos($_SERVER['PHP_SELF'], 'checkout_amazon_set_address.php') !== false || strpos($PHP_SELF, 'checkout_amazon_set_address.php') !== false) {
            require_once(DIR_FS_CATALOG . 'AmazonLoginAndPay/js/checkout_amazon_set_address_js.php');
        } elseif (strpos($_SERVER['PHP_SELF'], 'checkout_amazon_login_processing.php') !== false || strpos($PHP_SELF, 'checkout_amazon_login_processing.php') !== false) {
            require_once(DIR_FS_CATALOG . 'AmazonLoginAndPay/js/checkout_amazon_login_processing_js.php');
        }elseif (strpos($_SERVER['PHP_SELF'], 'checkout_amazon_pay.php') !== false || strpos($PHP_SELF, 'checkout_amazon_pay.php') !== false) {
            require_once(DIR_FS_CATALOG . 'AmazonLoginAndPay/js/checkout_amazon_pay_js.php');
        }
        ?>

        <?php
        $amzJsPath = (MODULE_PAYMENT_AM_APA_MODE == 'live' ? 'https://static-eu.payments-amazon.com/OffAmazonPayments/de/lpa/js/Widgets.js' : 'https://static-eu.payments-amazon.com/OffAmazonPayments/de/sandbox/lpa/js/Widgets.js');
        ?>
        if ($('#payWithAmazonDiv, .amazonLoginWr, #walletWidgetDiv, #addressBookWidgetDiv, .amazonPayButton').length) {
            document.write('\x3Cscript async="async" type="text/javascript" src="<?php echo $amzJsPath; ?>">\x3C/script>');
        }
    <?php
    if (strpos($PHP_SELF, 'product_info.php') !== false) {
        if ($useRedirect) {
            ?>
            function replaceBuyProductWithAmazonButton(){
                var buyProductWithAmazonButtonImg = $('#payWithAmazonDiv').find('img');
                if(buyProductWithAmazonButtonImg.length > 0){
                    $('.buyProductWithAmazonButton').show().find('img').attr('src', buyProductWithAmazonButtonImg.attr('src')).show();
                }
            }
            replaceBuyProductWithAmazonButton();
            setTimeout(replaceBuyProductWithAmazonButton, 500);
            setTimeout(replaceBuyProductWithAmazonButton, 1000);
            setTimeout(replaceBuyProductWithAmazonButton, 2000);
            setTimeout(replaceBuyProductWithAmazonButton, 3000);
        <?php } else { ?>
            $(document).ready(function(){
                $('#buyProductWithAmazonOriginalButtonWr').show();
            });
            <?php
        }
    }
    ?>
    </script>
    <?php
}

